//---------------------------------------------------------------------------

#ifndef ThreadCommH
#define ThreadCommH
//---------------------------------------------------------------------------
#include <syncobjs.hpp>
#include "Mutex.h"
//---------------------------------------------------------------------------

extern TCriticalSection *SC;
extern struct usb_dev_handle *usb_handle;
extern bool writeLock;
extern int regIdx;

class ThreadComm
{
private:
	typedef void (*CallbackLog)(char*);
	typedef void (*CallbackData)(short*, int);
	typedef void (*CallbackTrigger)(void);
	typedef void (*CallbackConnect)(int, char*);
	Mutex mutexSend;
	int iBufferSamples;	///< number of samples that are expected to be sent by device after triggering
	bool bContinuousTrigger;

protected:
public:
	bool connected;
   	CallbackLog callbackLog;
	CallbackData callbackData;
	CallbackTrigger callbackTrigger;
	CallbackConnect callbackConnect;
	char logtxt[60];
	__fastcall ThreadComm(bool CreateSuspended);
	int progressPercent;
//    DWORD dwBytesRead;
	int ret;

	HANDLE Thread;
	void Execute();
	void Terminate();
	/** \brief Send command to armscope device
		\param cmd first byte of command
		\param val second byte of command (value or subcommand)
		\param bImmediate skip command queue (send immediately)
		\return zero on success
	*/
	int SendCmd(unsigned char cmd, unsigned char val, bool bImmediate = true);
	void log(char *lpData, ...);
	void SetBufferSize(int samples) {
    	iBufferSamples = samples;
	}
	int GetBufferSize(void) {
    	return iBufferSamples;
	}
	void EndOfFrame(void);
	void SetContinuousTrigger(bool state) {
    	bContinuousTrigger = state;
	}
};
//---------------------------------------------------------------------------
#endif
